# Modules always contain just 32-bit code
%define _libdir %{_exec_prefix}/lib

%ifarch %{sparc}
%define _target_platform sparc64-%{_vendor}-%{_target_os}%{?_gnu}
%endif

%if ! 0%{?efi}

%global efiarchs x86_64

%ifarch %{ix86}
%global grubefiarch i386-efi
%global grubefiname grubia32.efi
%global grubeficdname gcdia32.efi
%endif
%ifarch x86_64
%global grubefiarch %{_arch}-efi
%global grubefiname grubx64.efi
%global grubeficdname gcdx64.efi
%endif

%if 0%{?rhel}
# This should be oracle but to deal with compat we make it redhat.
%global efidir redhat
%endif
%if 0%{?fedora}
%global efidir fedora
%endif

%endif

%global tarversion 2.02
%undefine _missing_build_ids_terminate_build

Name:           grub2-ovs
# We want the packages to be called grub2-ovs but the tools to be called
# grub2
%define _name grub2
Version:        2.02
Release: 0.8%{?dist}.3
Epoch: 2
Summary:        Bootloader with support for Linux, Multiboot and more

Group:          System Environment/Base
License:        GPLv3+
URL:            http://www.gnu.org/software/grub/
Provides: grub
Obsoletes:	grub < 0.98
Source0:        grub-2.02.tar.gz
Source4:	unifont-5.1.20080820.pcf.gz

Patch0001: 0001-relocator-Do-not-use-memory-region-if-its-starta-is-.patch
Patch0002: 0002-i386-relocator-Add-grub_relocator64_efi-relocator.patch
Patch0003: 0003-multiboot2-Add-tags-used-to-pass-ImageHandle-to-load.patch
Patch0004: 0004-multiboot2-Add-support-for-relocatable-images.patch
Patch0005: 0005-multiboot2-Do-not-pass-memory-maps-to-image-if-EFI-b.patch
Patch6: rev13.patch
Patch7: rev34.patch
Patch8: rev64.patch
Patch9: rev95.patch
Patch10: rev114.patch
# End Oracle Patches

BuildRequires:  flex bison binutils python
BuildRequires:  ncurses-devel xz-devel
BuildRequires:  freetype-devel libusb-devel
%ifarch %{sparc} x86_64
# sparc builds need 64 bit glibc-devel - also for 32 bit userland
BuildRequires:  /usr/lib64/crt1.o glibc-static
%else
# ppc64 builds need the ppc crt1.o
BuildRequires:  /usr/lib/crt1.o glibc-static
%endif
BuildRequires:  autoconf automake device-mapper-devel
BuildRequires:	freetype-devel gettext-devel git
BuildRequires:	texinfo
BuildRequires:	dejavu-sans-fonts
BuildRequires:	help2man

#Requires:	gettext os-prober which file
Requires:      gettext which file
#Requires:	%{name}-tools = %{epoch}:%{version}-%{release}
Requires(pre):  dracut
Requires(post): dracut

ExclusiveArch:  i386 x86_64
Obsoletes:	grub < 2.00

%description
The GRand Unified Bootloader (GRUB) is a highly configurable and customizable
bootloader with modular architecture.  It support rich varietyof kernel formats,
file systems, computer architectures and hardware devices.  This subpackage
provides support for PC BIOS systems.

%ifarch %{efiarchs}
%package efi
Summary:	GRUB for EFI systems.
Group:		System Environment/Base
Obsoletes:	grub-efi < 2.00

%description efi
The GRand Unified Bootloader (GRUB) is a highly configurable and customizable
bootloader with modular architecture.  It support rich varietyof kernel formats,
file systems, computer architectures and hardware devices.  This subpackage
provides support for EFI systems.
%endif

%package tools
Summary:	Support tools for GRUB.
Group:		System Environment/Base
#Requires:	gettext os-prober which file system-logos
Requires:      gettext which file system-logos

%description tools
The GRand Unified Bootloader (GRUB) is a highly configurable and customizable
bootloader with modular architecture.  It support rich varietyof kernel formats,
file systems, computer architectures and hardware devices.  This subpackage
provides tools for support of all platforms.

%package starfield-theme
Summary:	An example theme for GRUB.
Group:		System Environment/Base
Requires:	system-logos
Obsoletes:	grub < 2.00
Obsoletes:	grub-efi < 2.00

%description starfield-theme
The GRand Unified Bootloader (GRUB) is a highly configurable and customizable
bootloader with modular architecture.  It support rich varietyof kernel formats,
file systems, computer architectures and hardware devices.  This subpackage
provides an example theme for the grub screen.

%prep
%setup -T -c -n grub-%{tarversion}
%ifarch %{efiarchs}
%setup -D -q -T -a 0 -n grub-%{tarversion}
cd grub-%{tarversion}
# place unifont in the '.' from which configure is run
cp %{SOURCE4} unifont.pcf.gz
%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch6 -p0
%patch7 -p0
%patch8 -p0
%patch9 -p0
%patch10 -p0 -E

cd ..
mv grub-%{tarversion} grub-efi-%{tarversion}
%endif
%setup -D -q -T -a 0 -n grub-%{tarversion}
cd grub-%{tarversion}
# place unifont in the '.' from which configure is run
cp %{SOURCE4} unifont.pcf.gz
%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch6 -p0
%patch7 -p0
%patch8 -p0
%patch9 -p0
%patch10 -p0 -E

%build
%ifarch %{efiarchs}
cd grub-efi-%{tarversion}
./autogen.sh

set -e
%dump
# We must have the 64-bit version of EFI.
%define _target_platform x86_64-%{_vendor}-%{_target_os}%{?_gnu}

# We must also disable the stack protector.
%configure                                                      \
        CFLAGS="$(echo $RPM_OPT_FLAGS | sed                     \
                -e 's/-O.//g'                                   \
                -e 's/--param=ssp-buffer-size=4//g'             \
                -e 's/-mregparm=3/-mregparm=4/g'                \
                -e 's/-fexceptions//g'                          \
                -e 's/-strong//g'	                        \
		-e 's/-fstack-protector//g'			\
                -e 's/-fasynchronous-unwind-tables//g'          \
                -e 's/^/ -fno-strict-aliasing /' )              \
                -Wl,-rpath,\\\$\$ORIGIN/../lib"                 \
        TARGET_LDFLAGS=-static                                  \
        --with-platform=efi                                     \
        --with-grubdir=%{_name}                                  \
        --program-transform-name=s,grub,%{_name},                \
        --disable-grub-mount                                    \
        --disable-werror

make %{?_smp_mflags}

GRUB_MODULES=" loadenv all_video boot btrfs cat chain configfile echo efifwsetup \
                efinet ext2 fat font gfxmenu gfxterm gzio halt hfsplus iso9660 \
                jpeg lvm minicmd normal part_apple part_msdos \
                part_gpt password_pbkdf2 png reboot search search_fs_uuid \
                search_fs_file search_label sleep test video xfs \
                mdraid09 mdraid1x multiboot2 multiboot tftp serial"

./grub-mkimage -O %{grubefiarch} -o %{grubeficdname} -p /EFI/BOOT \
		-d grub-core ${GRUB_MODULES}

./grub-mkimage -O %{grubefiarch} -o %{grubefiname} -p /EFI/%{efidir} \
		-d grub-core ${GRUB_MODULES}

cd ..
%endif

cd grub-%{tarversion}
./autogen.sh
%ifarch x86_64
                #-e 's/-fstack-protector[[:alpha:]-]\+//g'       \
# 64bit intel machines use 32bit boot loader
# (We cannot just redefine _target_cpu, as we'd get i386.rpm packages then)
# sparc is always compiled 64 bit
%define _target_platform i386-%{_vendor}-%{_target_os}%{?_gnu}
%endif
%configure                                                      \
        CFLAGS="$(echo $RPM_OPT_FLAGS | sed                     \
                -e 's/-O.//g'                                   \
                -e 's/--param=ssp-buffer-size=4//g'             \
                -e 's/-mregparm=3/-mregparm=4/g'                \
                -e 's/-fexceptions//g'                          \
                -e 's/-m64//g'                                  \
                -e 's/-strong//g'                               \
                -e 's/-fasynchronous-unwind-tables//g'          \
		-e 's/-fstack-protector//g'			\
                -e 's/-mcpu=power7/-mcpu=power6/g'              \
                -e 's/^/ -fno-strict-aliasing /' )              \
                -Wl,-rpath,\\\$\$ORIGIN/../lib"                 \
        TARGET_LDFLAGS=-static                                  \
        --with-platform=pc                                      \
        --with-grubdir=%{_name}                                  \
        --program-transform-name=s,grub,%{_name},                \
        --disable-grub-mount                                    \
        --disable-werror

make %{?_smp_mflags}
sed -i -e 's,(grub),(%{_name}),g' \
        -e 's,grub.info,%{_name}.info,g' \
        -e 's,\* GRUB:,* GRUB2:,g' \
        -e 's,/boot/grub/,/boot/%{_name}/,g' \
        -e 's,\([^-]\)grub-\([a-z]\),\1%{_name}-\2,g' \
        docs/grub.info
sed -i -e 's,grub-dev,%{_name}-dev,g' docs/grub-dev.info


/usr/bin/makeinfo --html --no-split -I docs -o grub-dev.html docs/grub-dev.texi
/usr/bin/makeinfo --html --no-split -I docs -o grub.html docs/grub.texi
sed -i  -e 's,/boot/grub/,/boot/%{_name}/,g' \
        -e 's,\([^-]\)grub-\([a-z]\),\1%{_name}-\2,g' \
        grub.html

%install
set -e
rm -fr $RPM_BUILD_ROOT

%ifarch %{efiarchs}
cd grub-efi-%{tarversion}
make DESTDIR=$RPM_BUILD_ROOT install
find $RPM_BUILD_ROOT -iname "*.module" -exec chmod a-x {} \;

# Ghost config file

install -m 755 -d $RPM_BUILD_ROOT/boot/efi/EFI/%{efidir}/
touch $RPM_BUILD_ROOT/boot/efi/EFI/%{efidir}/grub.cfg
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}
ln -s ../boot/efi/EFI/%{efidir}/grub.cfg $RPM_BUILD_ROOT%{_sysconfdir}/%{_name}-efi.cfg

# Install ELF files modules and images were created from into
# the shadow root, where debuginfo generator will grab them from
find $RPM_BUILD_ROOT -name '*.mod' -o -name '*.img' |
while read MODULE
do
        BASE=$(echo $MODULE |sed -r "s,.*/([^/]*)\.(mod|img),\1,")
        # Symbols from .img files are in .exec files, while .mod
        # modules store symbols in .elf. This is just because we
        # have both boot.img and boot.mod ...
        EXT=$(echo $MODULE |grep -q '.mod' && echo '.elf' || echo '.exec')
        TGT=$(echo $MODULE |sed "s,$RPM_BUILD_ROOT,.debugroot,")
#        install -m 755 -D $BASE$EXT $TGT
done
install -m 755 %{grubefiname} $RPM_BUILD_ROOT/boot/efi/EFI/%{efidir}/%{grubefiname}
install -m 755 %{grubeficdname} $RPM_BUILD_ROOT/boot/efi/EFI/%{efidir}/%{grubeficdname} 
install -D -m 644 unicode.pf2 $RPM_BUILD_ROOT/boot/efi/EFI/%{efidir}/fonts/unicode.pf2
cd ..
%endif

cd grub-%{tarversion}
make DESTDIR=$RPM_BUILD_ROOT install

# Ghost config file
install -d $RPM_BUILD_ROOT/boot/%{_name}
touch $RPM_BUILD_ROOT/boot/%{_name}/grub.cfg
ln -s ../boot/%{_name}/grub.cfg $RPM_BUILD_ROOT%{_sysconfdir}/%{_name}.cfg

# Install ELF files modules and images were created from into
# the shadow root, where debuginfo generator will grab them from
find $RPM_BUILD_ROOT -name '*.mod' -o -name '*.img' |
while read MODULE
do
        BASE=$(echo $MODULE |sed -r "s,.*/([^/]*)\.(mod|img),\1,")
        # Symbols from .img files are in .exec files, while .mod
        # modules store symbols in .elf. This is just because we
        # have both boot.img and boot.mod ...
        EXT=$(echo $MODULE |grep -q '.mod' && echo '.elf' || echo '.exec')
        TGT=$(echo $MODULE |sed "s,$RPM_BUILD_ROOT,.debugroot,")
done

mv $RPM_BUILD_ROOT%{_infodir}/grub.info $RPM_BUILD_ROOT%{_infodir}/%{_name}.info
mv $RPM_BUILD_ROOT%{_infodir}/grub-dev.info $RPM_BUILD_ROOT%{_infodir}/%{_name}-dev.info
rm $RPM_BUILD_ROOT%{_infodir}/dir

# Defaults
mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/default
touch ${RPM_BUILD_ROOT}%{_sysconfdir}/default/grub
mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig
ln -sf %{_sysconfdir}/default/grub \
	${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/grub

cd ..

# No special themes in /boot/grub2/themes/system/
cd $RPM_BUILD_ROOT
# Make selinux happy with exec stack binaries.
mkdir ${RPM_BUILD_ROOT}%{_sysconfdir}/prelink.conf.d/
cat << EOF > ${RPM_BUILD_ROOT}%{_sysconfdir}/prelink.conf.d/grub.conf
## these have execstack, and break under selinux
-b /usr/bin/grub-script-check
-b /usr/bin/grub-mkrelpath
-b /usr/bin/grub-fstest
-b /usr/sbin/grub-bios-setup
-b /usr/sbin/grub-probe
-b /usr/sbin/grub-sparc64-setup
-b /usr/sbin/grub-install
EOF

# for OVS we only want the Xen entries.
# We make it read-only so it won't be executed.
install -m 444 $RPM_BUILD_ROOT/%{_sysconfdir}/grub.d/10_linux  $RPM_BUILD_ROOT/%{_sysconfdir}/grub.d/30_linux
rm  $RPM_BUILD_ROOT/%{_sysconfdir}/grub.d/10_linux

%clean 
rm -rf $RPM_BUILD_ROOT

%post
if [ "$1" = 1 ]; then
	/sbin/install-info --info-dir=%{_infodir} %{_infodir}/%{_name}.info.gz || :
	/sbin/install-info --info-dir=%{_infodir} %{_infodir}/%{_name}-dev.info.gz || :
fi

%ifarch %{efiarchs}
%post efi

%endif

%triggerun -- grub < 1:1.99-4
# grub < 1.99-4 removed a number of essential files in postun. To fix upgrades
# from the affected grub2 packages, we first back up the files in triggerun and
# later restore them in triggerpostun.
# https://bugzilla.redhat.com/show_bug.cgi?id=735259

# Back up the files before uninstalling old grub2
mkdir -p /boot/grub.tmp &&
mv -f /boot/grub/*.mod \
      /boot/grub/*.img \
      /boot/grub/*.lst \
      /boot/grub/device.map \
      /boot/grub.tmp/ || :

%triggerpostun -- grub < 1:1.99-4
# ... and restore the files.
test ! -f /boot/grub/device.map &&
test -d /boot/grub.tmp &&
mv -f /boot/grub.tmp/*.mod \
      /boot/grub.tmp/*.img \
      /boot/grub.tmp/*.lst \
      /boot/grub.tmp/device.map \
      /boot/grub/ &&
rm -r /boot/grub.tmp/ || :

%preun
if [ "$1" = 0 ]; then
	/sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/%{_name}.info.gz || :
	/sbin/install-info --delete --info-dir=%{_infodir} %{_infodir}/%{_name}-dev.info.gz || :
fi

%files
%defattr(-,root,root,-)
%{_libdir}/grub/i386-pc/
%config(noreplace) %{_sysconfdir}/%{_name}.cfg
%ghost %config(noreplace) /boot/%{_name}/grub.cfg

%ifarch %{efiarchs}
%files efi
%defattr(-,root,root,-)
%config(noreplace) %{_sysconfdir}/%{_name}-efi.cfg
%{_libdir}/grub/%{grubefiarch}
%ghost %config(noreplace) /boot/efi/EFI/%{efidir}/grub.cfg
%attr(0755,root,root)/boot/efi/EFI/%{efidir}

%endif

%files tools
%defattr(-,root,root,-)
%dir %{_libdir}/grub/
%dir %{_datarootdir}/grub/
%dir %{_datarootdir}/grub/themes
%{_datarootdir}/grub/*
%{_sbindir}/%{_name}-bios-setup
%{_sbindir}/%{_name}-install
%{_sbindir}/%{_name}-macbless
%{_sbindir}/%{_name}-mkconfig
%{_sbindir}/%{_name}-ofpathname
%{_sbindir}/%{_name}-probe
%{_sbindir}/%{_name}-reboot
%{_sbindir}/%{_name}-set-default
%{_sbindir}/%{_name}-sparc64-setup
%{_bindir}/%{_name}-editenv
%{_bindir}/%{_name}-file
%{_bindir}/%{_name}-fstest
%{_bindir}/%{_name}-glue-efi
%{_bindir}/%{_name}-kbdcomp
%{_bindir}/%{_name}-menulst2cfg
%{_bindir}/%{_name}-mkfont
%{_bindir}/%{_name}-mkimage
%{_bindir}/%{_name}-mklayout
%{_bindir}/%{_name}-mknetdir
%{_bindir}/%{_name}-mkpasswd-pbkdf2
%{_bindir}/%{_name}-mkrelpath
%ifnarch %{sparc}
%{_bindir}/%{_name}-mkrescue
%endif
%{_bindir}/%{_name}-mkstandalone
%{_bindir}/%{_name}-render-label
%{_bindir}/%{_name}-script-check
%{_bindir}/%{_name}-syslinux2cfg
%{_sysconfdir}/bash_completion.d/grub
%{_sysconfdir}/prelink.conf.d/grub.conf
%attr(0700,root,root) %dir %{_sysconfdir}/grub.d
%config %{_sysconfdir}/grub.d/??_*
%{_sysconfdir}/grub.d/README
%attr(0644,root,root) %ghost %config(noreplace) %{_sysconfdir}/default/grub
%{_sysconfdir}/sysconfig/grub
%dir /boot/%{_name}
%{_infodir}/%{_name}*
%doc grub-%{tarversion}/COPYING grub-%{tarversion}/INSTALL
%doc grub-%{tarversion}/NEWS grub-%{tarversion}/README
%doc grub-%{tarversion}/THANKS grub-%{tarversion}/TODO
%doc grub-%{tarversion}/grub.html
%doc grub-%{tarversion}/grub-dev.html grub-%{tarversion}/docs/font_char_metrics.png
%doc %{_mandir}/man1/*
%doc %{_mandir}/man8/*

%changelog
* Wed Jan 25 2017 Jingjie Jiang <jingjie.jiang@oracle.com> - 2.02-0.8.el6.3 
- Fix the uefi pxe boot issue, grub.cfg with mac address [bug 24485392]  

* Fri Jul 29 2016 Konrad Wilk <konrad.wilk@oracle.com> - 2.02-0.8.el6.2 
- grub2: Change menu entry: Remove GNU/Linux and use UEK name if applicable.
  and replace it with Unbreakable Enterprise Kernel if it is an
  UEK kernel. Also use /etc/system-release to figure out the OS
  instead of keeping 'GNU/Linux' (this is copied from the 20_linux_xen
  change from bug 21951760).
  Acked-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Signed-off-by: Konrad Wilk <konrad.wilk@oracle.com> [bug 24348702]  

* Wed Jul 27 2016 Konrad Wilk <konrad.wilk@oracle.com> - 2.02-0.8.el6.1
- Don't rm an option to generate Linux entries. [bug 24348702]

* Fri Jan 08 2016 Carson Hovey <carson.hovey@oracle.com> - 2.02-0.8 
- Change grub2 menu entry: Add Oracle VM Server, Remove GNU/Linux, add xen version
  Bug-fixed-by: Carson Hovey <carson.hovey@oracle.com>
  Signed-off-by: Jingjie Jiang <jingjie.jiang@oracle.com>
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Konrad Wilk <konrad.wilk@oracle.com> [bug 21951760]

* Wed Nov 25 2015 Livy Ge <livy.ge@oracle.com> - 2.02-0.7
- grub2-ovs.spec change for pxeboot installation (jingjie.jiang) [bug 22270332]

* Wed Oct 07 2015 Daniel Kiper <daniel.kiper@oracle.com> - 2.02-0.6
- Fix PXE boot on UEFI platforms (bug 17458093):
    1) update GRUB2 to upstream commit c93d3e694713b8230fa2cf88414fabe005b56782
       (cryptodisk: strip parenthesis from backing device name),
    2) use latest multiboot2 patches (v2 posted on grub-devel and
       Xen-devel on Mon Jul 20 2015).

* Tue Aug 18 2015 Jingjie Jiang <jingjie.jiang@oracle.com> - 2.02-0.5 
- Eliminate the menuentries to only xen.gz 

* Wed Jul 08 2015 Jingjie Jiang <Jingjie.jiang@oracle.com> - 2.02-0.4
- switch efidir from oracle to redhat [orabug 21394057]

* Wed May 13 2015 Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> - 2.02-0.3
- Use grub-file to figure out whether multiboot2 should be used for Xen.gz

* Mon Jan 5 2015 Jingjie Jiang <Jingjie.jiang@oracle.com> - 2.02-0.2 
- get grub-2.02 from upstream

